//+------------------------------------------------------------------+
//|                                            SafeFractalsFinal.mq4 |
//|                        Copyright  2007, HomeSoft - Tartan Corp. |
//|                                              spiky@transkeino.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, HomeSoft - Tartan Corp."
#property link      "www.fxexpert.ru"
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Gold
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Gold
#property indicator_color5 Magenta

//---- input parameters
extern int   info = 0;
extern int   mBar = 50;
//---- buffers
double dUpSignalBuffer[];
double dDownSignalBuffer[];
double SSignalBuffer[];
double BSignalBuffer[];
double RBuffer[];
double prUpFr,prDnFr,minDnFr,maxUpFr,oldSFr,oldBFr,del,profit,size;
int    sbar,bbar,pr,trend;
bool   ft=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping  
   SetIndexBuffer(0,dUpSignalBuffer);
   SetIndexBuffer(1,dDownSignalBuffer);
   SetIndexBuffer(2,SSignalBuffer);
   SetIndexBuffer(3,BSignalBuffer);
   SetIndexBuffer(4,RBuffer);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(0,159);//buy
   SetIndexStyle(1,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(1,159);//sell
   SetIndexStyle(2,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(2,242);//trend=-1   
   SetIndexStyle(3,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(3,241);//trend=1       
   SetIndexStyle(4,DRAW_SECTION,EMPTY,2,Magenta);//myZiZag
//----
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);   
   SetIndexEmptyValue(3,0.0);   
   SetIndexEmptyValue(4,0.0);  
//---- name for DataWindow
   SetIndexLabel(0,"FrUp");
   SetIndexLabel(1,"FrDn");
   SetIndexLabel(2,"2SFrac"); 
   SetIndexLabel(3,"3BFrac");  
   SetIndexLabel(4,"TrendLine");      
//---- initialization done   
   IndicatorShortName("SFractal");
   SetIndexDrawBegin(4,100);
//   ArrayInitialize(RBuffer,1);   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
  Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,j,nCountedBars;
   nCountedBars=IndicatorCounted();
//---- check for possible errors
   if(nCountedBars<0 || Bars<5) return(-1);
//   if(Hour()<12) return(0); 
//----
   if (ft)
    { 
   if (Period()==1440) del=50; 
   else
    {  Comment("   =D1");return(0);}
   if (Point>0.0002) pr=2; else pr=4;
       ft=false;
    }
    i=mBar;minDnFr=1000;maxUpFr=0;
   if (sbar==0 || bbar==0)
    {     
   if (High[1]>High[mBar]) sbar=1; else sbar=mBar;
   if (Low[1]<Low[mBar]) bbar=1; else bbar=mBar;
    }
   while(i>=0)
     {
      //----Up and Down Fractals
      //----5 bars Fractal      
      if (High[i+1]>=High[i+2] && High[i+1]>High[i+3] && High[i+1]>High[i] && (Close[i]<Open[i] || Close[i+1]<Open[i+1]))
       {
          dDownSignalBuffer[i+1]=High[i+1]+3*Point;prUpFr=High[i+1]; 
      if (prUpFr!=0 && prUpFr!=oldSFr) oldSFr=prUpFr;       
      if (prUpFr>maxUpFr) {maxUpFr=prUpFr;sbar=i+1;}
       }
      if (Low[i+1]<=Low[i+2] && Low[i+1]<Low[i+3] && Low[i+1]<Low[i] && (Close[i]>Open[i] || Close[i+1]>Open[i+1]))
       {
          dUpSignalBuffer[i+1]=Low[i+1]-3*Point;prDnFr=Low[i+1]; 
      if (prDnFr!=0 && prDnFr!=oldBFr) oldBFr=prDnFr;        
      if (prDnFr<minDnFr) {minDnFr=prDnFr;bbar=i+1;}   
       }
       
      if (prUpFr!=0 && prUpFr<maxUpFr) prUpFr=0;
      if (prDnFr!=0 && prDnFr>minDnFr) prDnFr=0;  
 
 for (j=mBar;j>=2;j--)
  {
 double valup=iFractals(NULL,0,MODE_UPPER,j);
  if (valup==0 && dDownSignalBuffer[j]!=0) {dDownSignalBuffer[j]=0;}     
 double valdn=iFractals(NULL,0,MODE_LOWER,j);
  if (valdn==0 && dUpSignalBuffer[j]!=0) {dUpSignalBuffer[j]=0;} 
  }     
    
 if (prUpFr!=0) SSignalBuffer[sbar]=High[sbar]+del*Point; 
 if (i==0) SSignalBuffer[i]=0;  
 
 for (j=0;j<=Bars-1;j++) 
  {
 if (j>sbar) SSignalBuffer[j]=0;
 if (High[i]>maxUpFr && j<=sbar) SSignalBuffer[j]=0;
  }   
    
 if (prDnFr!=0) BSignalBuffer[bbar]=Low[bbar]-del*Point;   
 if (i==0) BSignalBuffer[i]=0;
 
 for (j=0;j<=Bars-1;j++) 
  {
 if (j>bbar) BSignalBuffer[j]=0;
 if (Low[i]<minDnFr && j<=bbar) BSignalBuffer[j]=0;  
  } 
        
     profit=((maxUpFr-minDnFr)/Point)-20;
       size=MathAbs((Close[0]-Open[0])/Point);
       
 if (sbar>bbar) trend=1; else trend=-1;      
     
 if (info==1) 
     Comment("SBar=",sbar,"  BBar=",bbar,"  Max=",maxUpFr,"  Min=",minDnFr,"  CandleSize=",size,
             "  PrUp=",prDnFr,"  PrDn=",prUpFr,"  Trend=",trend,"  Profit=",profit);
      
          i--;   
          continue;
     }
      RBuffer[bbar]=Low[bbar];
      RBuffer[sbar]=High[sbar];      
     
//----
   return(0);
  }
//+------------------------------------------------------------------+